Index: /branches/1.1dev/lib/AuthFile.inc.php
===================================================================
--- /branches/1.1dev/lib/AuthFile.inc.php	(revision 707)
+++ /branches/1.1dev/lib/AuthFile.inc.php	(revision 708)
@@ -22,5 +22,5 @@
      * @param optional array $params  A hash containing parameters.
      */
-    function AuthFile($params = array())
+    function __construct($params = array())
     {
         $this->_params = $params;
Index: /branches/1.1dev/lib/AuthSQL.inc.php
===================================================================
--- /branches/1.1dev/lib/AuthSQL.inc.php	(revision 707)
+++ /branches/1.1dev/lib/AuthSQL.inc.php	(revision 708)
@@ -20,5 +20,5 @@
      * @param optional array $params  A hash containing parameters.
      */
-    function AuthSQL($params = array())
+    function __construct($params = array())
     {
         global $CFG;
Index: /branches/1.1dev/lib/AuthorizeNet.inc.php
===================================================================
--- /branches/1.1dev/lib/AuthorizeNet.inc.php	(revision 707)
+++ /branches/1.1dev/lib/AuthorizeNet.inc.php	(revision 708)
@@ -105,5 +105,5 @@
      * @param optional array $_params  A hash containing parameters.
      */
-    function AuthorizeNet($params = array())
+    function __construct($params = array())
     {
         if (!function_exists('curl_init')) {
Index: /branches/1.1dev/lib/CSS.inc.php
===================================================================
--- /branches/1.1dev/lib/CSS.inc.php	(revision 707)
+++ /branches/1.1dev/lib/CSS.inc.php	(revision 708)
@@ -23,5 +23,5 @@
      * Constructor.
      */
-    function CSS()
+    function __construct()
     {
         $this->_params['character_set'] = isset($CFG->character_set) ? $CFG->character_set : $this->_params['character_set'];
Index: /branches/1.1dev/lib/Captcha.inc.php
===================================================================
--- /branches/1.1dev/lib/Captcha.inc.php	(revision 707)
+++ /branches/1.1dev/lib/Captcha.inc.php	(revision 708)
@@ -118,5 +118,5 @@
      * @since   20 Jan 2006 13:08:22
      */
-    function Captcha()
+    function __construct()
     {
         global $CFG;
Index: /branches/1.1dev/lib/Cart.inc.php
===================================================================
--- /branches/1.1dev/lib/Cart.inc.php	(revision 707)
+++ /branches/1.1dev/lib/Cart.inc.php	(revision 708)
@@ -38,5 +38,5 @@
     // $this->shiprate["French_Postal"][2][1]["cost"]		= 2.06;
 	
-    function Cart()
+    function __construct()
     {
         $this->init();
Index: /branches/1.1dev/lib/Email.inc.php
===================================================================
--- /branches/1.1dev/lib/Email.inc.php	(revision 707)
+++ /branches/1.1dev/lib/Email.inc.php	(revision 708)
@@ -66,5 +66,5 @@
      * @since   28 Nov 2005 12:59:41
      */
-    function Email($params=null)
+    function __construct($params=null)
     {
         // The regex used in validEmail(). Set here instead of in the default _params above so we can use the concatination . dot.
Index: /branches/1.1dev/lib/Hierarchy.inc.php
===================================================================
--- /branches/1.1dev/lib/Hierarchy.inc.php	(revision 707)
+++ /branches/1.1dev/lib/Hierarchy.inc.php	(revision 708)
@@ -67,5 +67,5 @@
      *                          configuration or connection parameters.
      */
-    function Hierarchy($params=array())
+    function __construct($params=array())
     {
         $this->params = $params;
Index: /branches/1.1dev/lib/ImageThumb.inc.php
===================================================================
--- /branches/1.1dev/lib/ImageThumb.inc.php	(revision 707)
+++ /branches/1.1dev/lib/ImageThumb.inc.php	(revision 708)
@@ -48,5 +48,5 @@
      * 
      */
-    function ImageThumb()
+    function __construct()
     {
 //         if (!file_exists($this->anytopnm_binary)) {
Index: /branches/1.1dev/lib/MCVE.inc.php
===================================================================
--- /branches/1.1dev/lib/MCVE.inc.php	(revision 707)
+++ /branches/1.1dev/lib/MCVE.inc.php	(revision 708)
@@ -20,5 +20,5 @@
     var $ca_bundle = '/usr/share/ssl/certs/ca-bundle.crt';
     
-    function MCVE($username, $password)
+    function __construct($username, $password)
     {
         // Ensure PHP was compiled with the MCVE functions.
Index: /branches/1.1dev/lib/Nav.inc.php
===================================================================
--- /branches/1.1dev/lib/Nav.inc.php	(revision 707)
+++ /branches/1.1dev/lib/Nav.inc.php	(revision 708)
@@ -26,5 +26,5 @@
      * Constructor. Set default features to apply to all added pages.
      */
-    function Nav($default_features=null)
+    function __construct($default_features=null)
     {
         if (isset($default_features) && is_array($default_features)) {
Index: /branches/1.1dev/lib/PEdit.inc.php
===================================================================
--- /branches/1.1dev/lib/PEdit.inc.php	(revision 707)
+++ /branches/1.1dev/lib/PEdit.inc.php	(revision 708)
@@ -64,5 +64,5 @@
      * @param optional array $params  A hash containing connection parameters. 
      */ 
-    function PEdit($authorized=false)
+    function __construct($authorized=false)
     {
         if ($authorized === true) {
Index: /branches/1.1dev/lib/PageNumbers.inc.php
===================================================================
--- /branches/1.1dev/lib/PageNumbers.inc.php	(revision 707)
+++ /branches/1.1dev/lib/PageNumbers.inc.php	(revision 708)
@@ -54,5 +54,5 @@
      * PageNumbers constructor. All arguments are depreciated. Use set* functions instead.
      */
-    function PageNumbers()
+    function __construct()
     {
         // Default options for the quantity per page links.
Index: /branches/1.1dev/lib/PageSequence.inc.php
===================================================================
--- /branches/1.1dev/lib/PageSequence.inc.php	(revision 707)
+++ /branches/1.1dev/lib/PageSequence.inc.php	(revision 708)
@@ -30,5 +30,5 @@
      * @access public
      */
-    function PageSequence($params)
+    function __construct($params)
     {
         $this->sequence_title = isset($params['sequence_title']) ? $params['sequence_title'] : 'no_title';
Index: /branches/1.1dev/lib/PayPal.inc.php
===================================================================
--- /branches/1.1dev/lib/PayPal.inc.php	(revision 707)
+++ /branches/1.1dev/lib/PayPal.inc.php	(revision 708)
@@ -29,5 +29,5 @@
      * @param   bool    $test_mode  Use PayPal sandbox for testing.
      */
-    function PayPal($test_mode=false)
+    function __construct($test_mode=false)
     {
         if ($test_mode) {
Index: /branches/1.1dev/lib/Prefs.inc.php
===================================================================
--- /branches/1.1dev/lib/Prefs.inc.php	(revision 707)
+++ /branches/1.1dev/lib/Prefs.inc.php	(revision 708)
@@ -35,5 +35,5 @@
      * Prefs constructor.
      */
-    function Prefs($dbh=false, $params=array())
+    function __construct($dbh=false, $params=array())
     {
         $this->params = $params;
Index: /branches/1.1dev/lib/RecordLock.inc.php
===================================================================
--- /branches/1.1dev/lib/RecordLock.inc.php	(revision 707)
+++ /branches/1.1dev/lib/RecordLock.inc.php	(revision 708)
@@ -22,5 +22,5 @@
      * @param string $title       A title to apply to the lock, for display purposes.
      */
-    function RecordLock($auth_object=null)
+    function __construct($auth_object=null)
     {
         // Expire old locks.
Index: /branches/1.1dev/lib/SOAP_Google.inc.php
===================================================================
--- /branches/1.1dev/lib/SOAP_Google.inc.php	(revision 707)
+++ /branches/1.1dev/lib/SOAP_Google.inc.php	(revision 708)
@@ -61,5 +61,5 @@
     * @access public
     */
-    function SOAP_Google($licenseKey)
+    function __construct($licenseKey)
     {
         $this->_licenseKey = $licenseKey;
Index: /branches/1.1dev/lib/SortOrder.inc.php
===================================================================
--- /branches/1.1dev/lib/SortOrder.inc.php	(revision 707)
+++ /branches/1.1dev/lib/SortOrder.inc.php	(revision 708)
@@ -39,5 +39,5 @@
      *                               current order.
      */
-    function SortOrder($default_sort = '', $default_order = '')
+    function __construct($default_sort = '', $default_order = '')
     {
         global $CFG;
Index: /branches/1.1dev/lib/SpellCheck.inc.php
===================================================================
--- /branches/1.1dev/lib/SpellCheck.inc.php	(revision 707)
+++ /branches/1.1dev/lib/SpellCheck.inc.php	(revision 708)
@@ -31,5 +31,5 @@
      * @param  array    $params     Array of parameters (key => val pairs).
      */
-    function SpellCheck($params)
+    function __construct($params)
     {
 		if (!is_array($params) || empty($params)) {
Index: /trunk/lib/Auth_Simple.inc.php
===================================================================
--- /trunk/lib/Auth_Simple.inc.php	(revision 707)
+++ /trunk/lib/Auth_Simple.inc.php	(revision 708)
@@ -35,5 +35,5 @@
      * @param optional array $params  A hash containing parameters.
      */
-    function Auth_Simple($namespace='')
+    function __construct($namespace='')
     {
     	$app =& App::getInstance();