Index: /branches/1.1dev/bin/module_maker/_config.inc.php
===================================================================
--- /branches/1.1dev/bin/module_maker/_config.inc.php	(revision 753)
+++ /branches/1.1dev/bin/module_maker/_config.inc.php	(revision 754)
@@ -20,4 +20,5 @@
 }
 
+$CFG = new stdClass;
 $CFG->enable_session = false;
 $CFG->log_file_priority = false;
@@ -28,5 +29,2 @@
 
 require_once dirname(__FILE__) . '/../../config/boot.inc.php';
-
-
-?>
Index: /branches/1.1dev/config/boot.inc.php
===================================================================
--- /branches/1.1dev/config/boot.inc.php	(revision 753)
+++ /branches/1.1dev/config/boot.inc.php	(revision 754)
@@ -195,5 +195,5 @@
         // Database session handling.
         require_once CODE_BASE . '/lib/MySQLSessionHandler.inc.php';
-        $sess_mysql['dbh']             =& $dbh;            // MySQL link identifyer, if we are already connected to the database
+        $sess_mysql['dbh']             =& $dbh;           // MySQL link identifier, if we are already connected to the database
         $sess_mysql['hostname']        = 'localhost';     // MySQL hostname
         $sess_mysql['user']            = $CFG->username;  // MySQL username
@@ -218,33 +218,4 @@
         $_SESSION['_messages'] = array();
     }
-
-//     if (isset($_COOKIE[session_name()])) {
-//         logMsg(sprintf('Found session in cookie: %s=%s', session_name(), $_COOKIE[session_name()]), LOG_DEBUG, __FILE__, __LINE__);
-//     }
-//     if (getPost(session_name())) {
-//         logMsg(sprintf('Found session in post: %s=%s', session_name(), getPost(session_name())), LOG_DEBUG, __FILE__, __LINE__);
-//     }
-//     if (getGet(session_name())) {
-//         logMsg(sprintf('Found session in get: %s=%s', session_name(), getGet(session_name())), LOG_DEBUG, __FILE__, __LINE__);
-//     }
-//     logMsg(sprintf('Using session %s=%s', session_name(), session_id()), LOG_DEBUG, __FILE__, __LINE__);
-
-
-    /******************************************************************************
-     * LANGUAGE
-     *****************************************************************************/
-
-    // Set the language.
-    if ($lang = getFormData('lang')) {
-        $_SESSION['_language'] = $lang;
-    } else if (!isset($_SESSION['_language'])) {
-        preg_match('/^([-[:alpha:]]+)/i', getenv('HTTP_ACCEPT_LANGUAGE'), $lang);
-        if (isset($lang[0]) && isset($CFG->site_langs[$lang[0]])) {
-            $_SESSION['_language'] = $lang[0];
-        } else {
-            $_SESSION['_language'] = 'en';
-        }
-    }
-
 } // end enable sessions ______________________________________________________
 
@@ -298,10 +269,4 @@
 ini_set('include_path',
     ini_get('include_path') . PATH_SEPARATOR .
-    SITE_BASE . '/_templates/' . $inc_lang . PATH_SEPARATOR .
-    CODE_BASE . '/templates/' . $inc_lang . PATH_SEPARATOR .
-
-    SITE_BASE . '/_templates/en' . PATH_SEPARATOR .
-    CODE_BASE . '/templates/en' . PATH_SEPARATOR .
-
     SITE_BASE . '/_templates' . PATH_SEPARATOR .
     CODE_BASE . '/templates' . PATH_SEPARATOR .
@@ -309,4 +274,2 @@
     SITE_BASE . '/../lib'
 );
-
-?>
Index: /branches/1.1dev/config/defaults.inc.php
===================================================================
--- /branches/1.1dev/config/defaults.inc.php	(revision 753)
+++ /branches/1.1dev/config/defaults.inc.php	(revision 754)
@@ -5,5 +5,5 @@
 
 /*
- * This file contains global configration variables that apply to the underlying
+ * This file contains global configuration variables that apply to the underlying
  * codebase framework. These values can be overwritten in a site-specific config
  * file to customize values for a specific site.
Index: /branches/1.1dev/css/utilities.inc.css
===================================================================
--- /branches/1.1dev/css/utilities.inc.css	(revision 753)
+++ /branches/1.1dev/css/utilities.inc.css	(revision 754)
Index: /branches/1.1dev/lib/AuthSQL.inc.php
===================================================================
--- /branches/1.1dev/lib/AuthSQL.inc.php	(revision 753)
+++ /branches/1.1dev/lib/AuthSQL.inc.php	(revision 754)
@@ -377,8 +377,8 @@
             $remote_ip_is_matched = (isset($_SESSION[$this->_auth_name]['remote_ip']) && $_SESSION[$this->_auth_name]['remote_ip'] == getRemoteAddr() || $user_in_trusted_network);
         } else {
-            logMsg(sprintf('%s%s exempt from remote_ip match.',
-                ucfirst($this->_params['auth_name']),
-                ($this->getVal('user_id') ? ' ' . $this->getVal('user_id') . ' (' .  $this->getVal('username') . ')' : '')
-            ), LOG_DEBUG, __FILE__, __LINE__);
+            // logMsg(sprintf('%s%s exempt from remote_ip match.',
+            //     ucfirst($this->_params['auth_name']),
+            //     ($this->getVal('user_id') ? ' ' . $this->getVal('user_id') . ' (' .  $this->getVal('username') . ')' : '')
+            // ), LOG_DEBUG, __FILE__, __LINE__);
             $remote_ip_is_matched = true;
         }
Index: /branches/1.1dev/lib/Utilities.inc.php
===================================================================
--- /branches/1.1dev/lib/Utilities.inc.php	(revision 753)
+++ /branches/1.1dev/lib/Utilities.inc.php	(revision 754)
@@ -726,4 +726,22 @@
 }
 
+/*
+* Generates a base-65-encoded sha512 hash of $string truncated to $length.
+*
+* @access   public
+* @param    string  $string Input string to hash.
+* @param    int     $length Length of output hash string.
+* @return   string          String of hash.
+* @author   Quinn Comendant <quinn@strangecode.com>
+* @version  1.0
+* @since    03 Apr 2016 19:48:49
+*/
+function hash64($string, $length=18)
+{
+    $app =& App::getInstance();
+
+    return mb_substr(preg_replace('/[^\w]/' . $app->getParam('preg_u'), '', base64_encode(hash('sha512', $string, true))), 0, $length);
+}
+
 /**
  * Signs a value using md5 and a simple text key. In order for this